unit ExceptionTest;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls;

type
  TExceptionTestForm = class(TForm)
    ProductList: TListBox;
    MessageList: TListBox;
    GetProduct: TButton;
    ClearMessageList: TButton;
    ProdNbrEdit: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure GetProductClick(Sender: TObject);
    procedure ClearMessageListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExceptionTestForm: TExceptionTestForm;

implementation

{$R *.xfm}

procedure TExceptionTestForm.FormCreate(Sender: TObject);
begin
    ProductList.Items.Add('Borland Kylix');
    ProductList.Items.Add('Borland C++Builder');
    ProductList.Items.Add('Borland Delphi');
    ProductList.Items.Add('Borland JBuilder');
end;

procedure TExceptionTestForm.GetProductClick(Sender: TObject);
var product: String;
var prodNbr: Integer;
begin
    try
        prodNbr := StrToInt(ProdNbrEdit.Text);
        product := ProductList.Items[prodNbr-1];
        MessageList.Items.Add('Found item in the list : '+product);
    except
    on E:Exception do
        begin
            MessageList.Items.Add('Wrong product number entered !!!');
            MessageList.Items.Add(E.Message);
        end;
    end;
end;

procedure TExceptionTestForm.ClearMessageListClick(Sender: TObject);
begin
    MessageList.Clear;
end;

end.
