package mdiproject;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.beans.*;
import javax.swing.filechooser.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class MainFrame extends JFrame implements ActionListener {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar mainMenu = new JMenuBar();
  JMenu fileMenu;
  JMenuItem fileNew;
  JMenuItem fileOpen;
  JMenuItem fileClose;
  JMenuItem fileExit;
  JDesktopPane mainFrameDesktop = new JDesktopPane();
  int xOffset = 20;
  int yOffset = 20;
  int nbrofChildrenCreated = 0;
  Vector childWindows = new Vector();

  //Construct the frame
  public MainFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(700, 600));
    this.setTitle("MDI Application");
    this.setJMenuBar(mainMenu);
    mainMenu.setVisible(true);
    fileMenu = new JMenu("File");
    mainMenu.add(fileMenu);

    fileNew = new JMenuItem("New");
    fileMenu.add(fileNew);
    fileOpen = new JMenuItem("Open");
    fileMenu.add(fileOpen);
    fileClose = new JMenuItem("Close");
    fileMenu.add(fileClose);
    fileMenu.addSeparator();
    fileExit = new JMenuItem("Exit");
    fileMenu.add(fileExit);

    fileNew.addActionListener(this);
    fileOpen.addActionListener(this);
    fileClose.addActionListener(this);
    fileExit.addActionListener(this);

    this.setContentPane(mainFrameDesktop);

  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  //
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == fileNew) {
      this.createNewWindow();
    }
    if (e.getSource() == fileOpen) {
      this.openTextFile();
    }
    if (e.getSource() == fileClose) {
      this.closeCurrentFile();
    }
    if (e.getSource() == fileExit) {
      System.exit(0);
    }
  }
  public void createNewWindow() {
    ChildFrame childFrame = new ChildFrame("New Child Window", false);
    mainFrameDesktop.add(childFrame);
    childFrame.setLocation(nbrofChildrenCreated*xOffset, nbrofChildrenCreated*yOffset);
    childWindows.add(childFrame);
    nbrofChildrenCreated++;
    try {
      childFrame.setSelected(true);
    }
    catch (PropertyVetoException e) {

    }
  }
  public void openTextFile() {
    JFileChooser fileChooser = new JFileChooser();
    fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
    int selectedValue = fileChooser.showOpenDialog(this);

    if (selectedValue == JFileChooser.APPROVE_OPTION) {
      ChildFrame childFrame = new ChildFrame(fileChooser.getSelectedFile().getPath(), true);
      mainFrameDesktop.add(childFrame);
      childFrame.setLocation(nbrofChildrenCreated*xOffset, nbrofChildrenCreated*yOffset);
      childWindows.add(childFrame);
      nbrofChildrenCreated++;
      try {
        childFrame.setSelected(true);
      }
      catch (PropertyVetoException e) {

      }
    }
  }
  public void closeCurrentFile() {
    for (int i=0; i < childWindows.size(); i++) {
      ChildFrame childWin = (ChildFrame)childWindows.get(i);
      if (childWin == null)
        continue;
      try {
        if (childWin.isSelected()) {
          if (childWin.buffReader != null)
            childWin.buffReader.close();
          childWin.dispose();
          childWindows.remove(i);
          break;
        }
      }
      catch (IOException ex) {
        System.out.println(ex.getMessage());
      }
    }
  }
}